program shallow

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!  Resolution eq. shallow_water 2D   
!!!!!  volumes finis, grille structuree cartesienne
!!!!!  schema decentre ordre 1 , dcomposition de flux cintique
!!!!! pas de traitement spcial du terme source => quilibres non prservs
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  !----------- sous programmes ------------------------------------ 
  use mod_precision   !- (double ou simple precision)
  use mod_flux !- calcul des demi-flux
  !----------------------------------------------------------------


  implicit none

  !------------ variables -----------------------------------------
  integer :: i,j,imax,jmax,nmax,n,k,pas_affichage
  character(len=100) :: numero,fich
  real(pr) :: Lx,Ly,dx,dy,pi,theta,alpha,g,cfl,invdt,dt,vmax,tmax
  real(pr), dimension(:), allocatable :: x,y,xc,yc
  real(pr), dimension(:,:), allocatable :: h,ux,uy,c,fhx,fhy,fuxx,fuxy,fuyx,fuyy,hnp1,huxnp1,huynp1,beta,b
  !----------------------------------------------------------------


  !--- constantes physiques et math.
  g=1._pr;
  pi=acos(-1._pr)

  !--- donnees exemple 1 : goutte, fond plat
  !- domaine de calcul
  Lx=2._pr; Ly=2._pr;
  !- maillage
  imax=250; jmax=50;
  dx=Lx/imax; dy=Ly/jmax;
  !- calcul des coordonnees des noeuds et des centres de maille
  allocate(x(0:imax),y(0:jmax),xc(1:imax),yc(1:jmax))
  x=(/(-Lx/2._pr+i*dx,i=0,imax)/)
  xc=(/(-Lx/2._pr+(i-0.5_pr)*dx,i=1,imax)/)
  yc=(/(-Ly/2._pr+(j-0.5_pr)*dy,j=1,jmax)/)
  y=(/(-Ly/2._pr+j*dy,j=0,jmax)/)
  !- topographie du fond
  allocate(b(0:imax+1,0:jmax+1))
  b=0._pr
  !- donne initiale
  allocate(h(0:imax+1,0:jmax+1))  
  h=0._pr
  do i=1,imax
     do j=1,jmax
        h(i,j)=0.03_pr/(2._pr*pi/15._pr**2)*exp(-(yc(j)+0.6_pr)**2/(2._pr/15._pr**2))*exp(-(xc(i)+0.6_pr)**2/(2._pr/15._pr**2));
     end do
  end do
  h=h+1._pr;

!!$  !--- donnees exemple 2 : lac au repos, fond avec butte cylindrique
!!$  !- domaine de calcul
!!$  Lx=10._pr; Ly=2._pr
!!$  !- maillage
!!$  imax=250; jmax=50;
!!$  dx=Lx/imax; dy=Ly/jmax;
!!$  !- calcul des coordonnees des noeuds et des centres de maille
!!$  allocate(x(0:imax),y(0:jmax),xc(1:imax),yc(1:jmax))
!!$  x=(/(-Lx/2._pr+i*dx,i=0,imax)/)
!!$  xc=(/(-Lx/2._pr+(i-0.5_pr)*dx,i=1,imax)/)
!!$  yc=(/(-Ly/2._pr+(j-0.5_pr)*dy,j=1,jmax)/)
!!$  y=(/(-Ly/2._pr+j*dy,j=0,jmax)/)
!!$  !- topographie du fond
!!$  allocate(b(0:imax+1,0:jmax+1))
!!$  b=0._pr
!!$  do i=1,imax
!!$     do j=1,jmax
!!$        if ((xc(i)-xc(125))**2+(yc(j)-yc(25))**2<=0.04_pr) then
!!$           b(i,j)=0.2_pr
!!$        end if
!!$     end do
!!$  end do
!!$  !- donne initiale
!!$  allocate(h(0:imax+1,0:jmax+1))
!!$  h=0._pr
!!$  do i=1,imax
!!$     h(i,:)=1._pr-b(i,:);   
!!$  end do
!!$
!!$  !--- donnees exemple 3 : rupture de barrage, fond plat
!!$  !- domaine de calcul
!!$  Lx=10._pr; Ly=2._pr
!!$  !- maillage
!!$  imax=250; jmax=50;
!!$  dx=Lx/imax; dy=Ly/jmax;
!!$  !- calcul des coordonnees des noeuds et des centres de maille
!!$  allocate(x(0:imax),y(0:jmax),xc(1:imax),yc(1:jmax))
!!$  x=(/(-Lx/2._pr+i*dx,i=0,imax)/)
!!$  xc=(/(-Lx/2._pr+(i-0.5_pr)*dx,i=1,imax)/)
!!$  yc=(/(-Ly/2._pr+(j-0.5_pr)*dy,j=1,jmax)/)
!!$  y=(/(-Ly/2._pr+j*dy,j=0,jmax)/)
!!$  !- topographie du fond
!!$  allocate(b(0:imax+1,0:jmax+1))
!!$  b=0._pr
!!$  !- donne initiale
!!$  allocate(h(0:imax+1,0:jmax+1))  
!!$  h=0._pr
!!$  do i=1,imax
!!$     if (xc(i)<=-4.0_pr) then
!!$        h(i,:)=2._pr-b(i,:);
!!$     else
!!$        h(i,:)=1._pr-b(i,:);   
!!$     end if
!!$  end do
!!$
!!$  !--- donnees exemple 4 : rupture de barrage, fond avec butte cylindrique
!!$  !- domaine de calcul
!!$  Lx=10._pr; Ly=2._pr
!!$  !- maillage
!!$  imax=250; jmax=50;
!!$  dx=Lx/imax; dy=Ly/jmax;
!!$  !- calcul des coordonnees des noeuds et des centres de maille
!!$  allocate(x(0:imax),y(0:jmax),xc(1:imax),yc(1:jmax))
!!$  x=(/(-Lx/2._pr+i*dx,i=0,imax)/)
!!$  xc=(/(-Lx/2._pr+(i-0.5_pr)*dx,i=1,imax)/)
!!$  yc=(/(-Ly/2._pr+(j-0.5_pr)*dy,j=1,jmax)/)
!!$  y=(/(-Ly/2._pr+j*dy,j=0,jmax)/)
!!$  !- topographie du fond
!!$  allocate(b(0:imax+1,0:jmax+1))
!!$  b=0._pr
!!$  do i=1,imax
!!$     do j=1,jmax
!!$        if ((xc(i)-xc(125))**2+(yc(j)-yc(25))**2<=0.04_pr) then
!!$           b(i,j)=0.2_pr
!!$        end if
!!$     end do
!!$  end do
!!$  !- donne initiale
!!$  allocate(h(0:imax+1,0:jmax+1)) 
!!$  h=0._pr
!!$  do i=1,imax
!!$     if (xc(i)<=-4.0_pr) then
!!$        h(i,:)=2._pr-b(i,:);
!!$     else
!!$        h(i,:)=1._pr-b(i,:);   
!!$     end if
!!$  end do
!!$
!!$  !--- donnees exemple 5 : rupture de barrage, avec le au milieu du canal
!!$  !- domaine de calcul
!!$  Lx=10._pr; Ly=2._pr
!!$  !- maillage
!!$  imax=250; jmax=50;
!!$  dx=Lx/imax; dy=Ly/jmax;
!!$  !- calcul des coordonnees des noeuds et des centres de maille
!!$  allocate(x(0:imax),y(0:jmax),xc(1:imax),yc(1:jmax))
!!$  x=(/(-Lx/2._pr+i*dx,i=0,imax)/)
!!$  xc=(/(-Lx/2._pr+(i-0.5_pr)*dx,i=1,imax)/)
!!$  yc=(/(-Ly/2._pr+(j-0.5_pr)*dy,j=1,jmax)/)
!!$  y=(/(-Ly/2._pr+j*dy,j=0,jmax)/)
!!$  !- topographie du fond
!!$  allocate(b(0:imax+1,0:jmax+1))
!!$  b=0._pr
!!$  do i=1,imax
!!$     do j=1,jmax
!!$        if ((xc(i)-xc(125))**2+(yc(j)-yc(25))**2<=0.04_pr) then
!!$           b(i,j)=1.5_pr
!!$        end if
!!$     end do
!!$  end do
!!$  !- donne initiale
!!$  allocate(h(0:imax+1,0:jmax+1)) 
!!$  h=0._pr
!!$  do i=1,imax
!!$     if (xc(i)<=-4.0_pr) then
!!$        h(i,:)=2._pr-b(i,:);
!!$     else
!!$        h(i,:)=1._pr-b(i,:);   
!!$     end if
!!$  end do
!!$
!!$  do i=1,imax
!!$     do j=1,jmax
!!$        if ((xc(i)-xc(125))**2+(yc(j)-yc(25))**2<=0.04_pr) then
!!$           h(i,j)=0._pr
!!$        end if
!!$     end do
!!$  end do


  !--- ci pour la vitesse : vitesse nulle
  allocate(ux(0:imax+1,0:jmax+1),uy(0:imax+1,0:jmax+1))
  ux=0._pr; uy=0._pr;

  !--- tableaux auxiliaires
  allocate(c(0:imax+1,0:jmax+1))
  c=sqrt(g*h)
  allocate(fhx(0:imax+1,1:jmax),fuxx(0:imax+1,1:jmax),fuyx(0:imax+1,1:jmax))
  allocate(fhy(1:imax,0:jmax+1),fuxy(1:imax,0:jmax+1),fuyy(1:imax,0:jmax+1))
  fhx=0._pr; fhy=0._pr; 
  fuxx=0._pr; fuxy=0._pr; 
  fuyx=0._pr; fuyy=0._pr;
  allocate(hnp1(1:imax,1:jmax),huxnp1(1:imax,1:jmax),huynp1(1:imax,1:jmax))
  hnp1=0._pr; 
  huxnp1=0._pr; 
  huynp1=0._pr;

  !--- paramtres maxwellienne
  theta=sqrt(3._pr/2._pr);
  alpha=1._pr/(4._pr*theta**2*g);
  allocate(beta(0:imax+1,0:jmax+1))
  beta=theta*c;

  !--- paramtre d'affichage et affichage ci
  pas_affichage=10
  k=0

  fich='SORTIES/resultats.0000.vtk'
  open(unit=1,file=fich)
  write(1,'(1A26)') '# vtk DataFile Version 2.0'
  write(1,*) 'shallow-water 2D'
  write(1,*) 'ASCII'
  write(1,*) 'DATASET RECTILINEAR_GRID'
  write(1,*) 'DIMENSIONS ',imax+1,jmax+1,1
  write(1,*) 'X_COORDINATES',imax+1,' double'
  do i=0,imax
     write(1,*) x(i)
  end do
  write(1,*) 'Y_COORDINATES',jmax+1,' double'
  do j=0,jmax
     write(1,*) y(j)
  end do
  write(1,*) 'Z_COORDINATES',1,' double'
  write(1,*) 0.0_pr

  write(1,*) 'CELL_DATA',imax*jmax
  write(1,*) 'SCALARS hauteur double'
  write(1,*) 'LOOKUP_TABLE default'
  do j=1,jmax
     do i=1,imax
        write(1,*) h(i,j)+b(i,j)
     end do
  end do

  write(1,*) 'SCALARS fond double'
  write(1,*) 'LOOKUP_TABLE default'
  do j=1,jmax
     do i=1,imax
        write(1,*) b(i,j)
     end do
  end do

  write(1,*) 'VECTORS u double'
  do j=1,jmax
     do i=1,imax
        write(1,*) ux(i,j),uy(i,j),0.0_pr
     end do
  end do
  close(1)

  !--- boucle en temps
  do n=1,1000

     !-- pas de temps
     dt=1._pr/(2._pr*maxval((abs(ux)+theta*c)/dx+(abs(uy)+theta*c)/dy));

!!$     !-- mise a jour des cl de reflection
!!$     for j=2:jmax+1
!!$         ! ouest
!!$         h(1,j)=h(2,j);
!!$         ux(1,j)=-ux(2,j);
!!$         uy(1,j)=uy(2,j);
!!$         ! est
!!$         h(imax+2,j)=h(imax+1,j);
!!$         ux(imax+2,j)=-ux(imax+1,j);
!!$         uy(imax+2,j)=uy(imax+1,j);
!!$     end
!!$     for i=2:imax+1
!!$         ! nord
!!$         h(i,1)=h(i,2);
!!$         ux(i,1)=ux(i,2);
!!$         uy(i,1)=-uy(i,2);
!!$         ! sud
!!$         h(i,jmax+2)=h(i,jmax+1);
!!$         ux(i,jmax+2)=ux(i,jmax+1);
!!$         uy(i,jmax+2)=-uy(i,jmax+1);
!!$     end

     !-- mise a jour des cl de sortie
     do j=1,jmax
        !- ouest
        h(0,j)=h(1,j);
        ux(0,j)=ux(1,j);
        uy(0,j)=uy(1,j);
        !- est
        h(imax+1,j)=h(imax,j);
        ux(imax+1,j)=ux(imax,j);
        uy(imax+1,j)=uy(imax,j);
     end do
     do i=1,imax
        !- nord
        h(i,0)=h(i,1);
        ux(i,0)=ux(i,1);
        uy(i,0)=uy(i,1);
        !- sud
        h(i,jmax+1)=h(i,jmax);
        ux(i,jmax+1)=ux(i,jmax);
        uy(i,jmax+1)=uy(i,jmax);
     end do


     !-- mise a jour beta et c
     c=sqrt(g*h); beta=theta*c;

     !-- calcul des flux en x
     do i=0,imax
        do j=1,jmax
           fhx(i,j)=fhp(ux(i,j),alpha,beta(i,j))+fhm(ux(i+1,j),alpha,beta(i+1,j));
           fuxx(i,j)=fup(ux(i,j),alpha,beta(i,j))+fum(ux(i+1,j),alpha,beta(i+1,j));
           fuyx(i,j)=uy(i,j)*fhp(ux(i,j),alpha,beta(i,j))+uy(i+1,j)*fhm(ux(i+1,j),alpha,beta(i+1,j));
        end do
     end do

     !-- calcul des flux en y
     do j=0,jmax
        do i=1,imax
           fhy(i,j)=fhp(uy(i,j),alpha,beta(i,j))+fhm(uy(i,j+1),alpha,beta(i,j+1));
           fuxy(i,j)=ux(i,j)*fhp(uy(i,j),alpha,beta(i,j))+ux(i,j+1)*fhm(uy(i,j+1),alpha,beta(i,j+1));
           fuyy(i,j)=fup(uy(i,j),alpha,beta(i,j))+fum(uy(i,j+1),alpha,beta(i,j+1));
        end do
     end do


     !-- iteration en temps
     do i=1,imax
        do j=1,jmax

           hnp1(i,j)=h(i,j)                                   &
                &                      -dt/dx*(fhx(i,j)-fhx(i-1,j))             &
                &                      -dt/dy*(fhy(i,j)-fhy(i,j-1));

           huxnp1(i,j)=h(i,j)*ux(i,j)                                 &
                &                      -dt/dx*(fuxx(i,j)-fuxx(i-1,j))             &
                &                      -dt/dy*(fuxy(i,j)-fuxy(i,j-1))             &
                &                      -dt*g*h(i,j)*(b(i+1,j)-b(i-1,j))/(2._pr*dx);

           huynp1(i,j)=h(i,j)*uy(i,j)                                &
                &                      -dt/dx*(fuyx(i,j)-fuyx(i-1,j))             &
                &                      -dt/dy*(fuyy(i,j)-fuyy(i,j-1))             &
                &                      -dt*g*h(i,j)*(b(i,j+1)-b(i,j-1))/(2._pr*dy);


        end do
     end do


     !-- mise a jour h, ux, uy
     h(1:imax,1:jmax)=hnp1
     do i=1,imax
        do j=1,jmax
           if (hnp1(i,j)/=0._pr) then
              ux(i,j)=huxnp1(i,j)/hnp1(i,j)
              uy(i,j)=huynp1(i,j)/hnp1(i,j)
           else
              ux(i,j)=0._pr
              uy(i,j)=0._pr
           end if
           
        end do
     end do
 
     !-- sauvegarde resultats (pour visit)
     if (mod(n,pas_affichage)==0) then

        k=k+1
        write(numero,*) k
        if (k<=9) then
           numero='000'//trim(adjustl(numero))
        elseif (9<k.and.k<=99) then
           numero='00'//trim(adjustl(numero))
        elseif (99<k.and.k<=999) then
           numero='0'//trim(adjustl(numero))
        end if


        fich='SORTIES/resultats.'//trim(adjustl(numero))//'.vtk'
        open(unit=1,file=fich)
        write(1,'(1A26)') '# vtk DataFile Version 2.0'
        write(1,*) 'shallow-water 2D'
        write(1,*) 'ASCII'
        write(1,*) 'DATASET RECTILINEAR_GRID'
        write(1,*) 'DIMENSIONS ',imax+1,jmax+1,1
        write(1,*) 'X_COORDINATES',imax+1,' double'
        do i=0,imax
           write(1,*) x(i)
        end do
        write(1,*) 'Y_COORDINATES',jmax+1,' double'
        do j=0,jmax
           write(1,*) y(j)
        end do
        write(1,*) 'Z_COORDINATES',1,' double'
        write(1,*) 0.0_pr

        write(1,*) 'CELL_DATA',imax*jmax
        write(1,*) 'SCALARS hauteur double'
        write(1,*) 'LOOKUP_TABLE default'
        do j=1,jmax
           do i=1,imax
              write(1,*) h(i,j)+b(i,j)
           end do
        end do

        write(1,*) 'SCALARS fond double'
        write(1,*) 'LOOKUP_TABLE default'
        do j=1,jmax
           do i=1,imax
              write(1,*) b(i,j)
           end do
        end do

        write(1,*) 'VECTORS u double'
        do j=1,jmax
           do i=1,imax
              write(1,*) ux(i,j),uy(i,j),0.0_pr
           end do
        end do
        close(1)

        print*,n

     end if

  end do

end program shallow
